﻿using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using GGJ_Engine;
using GGJ_Game.InterfaceElements;
using Microsoft.Xna.Framework;

namespace GGJ_Game
{
    class IngameHud : Interface
    {
        private ContentManager content;

        InterfaceElementUpgradeBar upgradeLeg;
        InterfaceElementUpgradeBar upgradeArm;
        InterfaceElementUpgradeBar upgradeEye;
        InterfaceElementUpgradeBar upgradeBrain;

        public bool ShowLeg
        {
            get { return showLeg; }
            set
            {
                if (value && showLeg == false)
                {
                    upgradeLeg.LoadContent();
                    elements.Add(upgradeLeg);
                }
                showLeg = value;
            }
        }
        bool showLeg = false;

        public bool ShowArm
        {
            get { return showArm; }
            set
            {
                if (value && showArm == false)
                {
                    upgradeArm.LoadContent();
                    elements.Add(upgradeArm);
                }
                showArm = value;
            }
        }
        bool showArm = false;

        public bool ShowEye
        {
            get { return showEye; }
            set
            {
                if (value && showEye == false)
                {
                    upgradeEye.LoadContent();
                    elements.Add(upgradeEye);
                }
                showEye = value;
            }
        }
        bool showEye = false;

        public bool ShowBrain
        {
            get { return showBrain; }
            set
            {
                if (value && showBrain == false)
                {
                    upgradeBrain.LoadContent();
                    elements.Add(upgradeBrain);
                }
                showBrain = value;
            }
        }
        bool showBrain = false;

        public IngameHud(GraphicsDevice device, ContentManager content)
            : base(device, content)
        {
            this.content = content;
        }

        public override void LoadContent()
        {
            InterfaceElementUpgradeBar upgradeBar = new InterfaceElementUpgradeBar(content, "screens/upgradebar");
            upgradeBar.Rectangle = new Rectangle(0, 0, 252, 78);
            this.elements.Add(upgradeBar);

            // Start with hidden elements, show then if the player get the needed items
            upgradeLeg = new InterfaceElementUpgradeBar(content, "screens/upgrade_leg");
            upgradeLeg.Rectangle = new Rectangle(0, 0, 142, 31);
            upgradeArm = new InterfaceElementUpgradeBar(content, "screens/upgrade_arm");
            upgradeArm.Rectangle = new Rectangle(0, 0, 142, 31);
            upgradeEye = new InterfaceElementUpgradeBar(content, "screens/upgrade_eye");
            upgradeEye.Rectangle = new Rectangle(0, 0, 142, 31);
            upgradeBrain = new InterfaceElementUpgradeBar(content, "screens/upgrade_brain");
            upgradeBrain.Rectangle = new Rectangle(0, 0, 142, 31);

            base.LoadContent();
        }
    }
}
